use std::path::PathBuf;
use config::Config;
use serde::{Deserialize, Serialize};
use crate::storage_manager::file_store::FileStoreConfig;
use crate::storage_manager::StorageTypes;

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct PicOxConfig {
    pub host: String,
    pub default_storage_method: StorageTypes,
    pub db_path: PathBuf,

    pub file_store_config: Option<FileStoreConfig>
}

impl PicOxConfig {
    pub fn new(config: PathBuf) -> PicOxConfig {
        let pic_ox_config =  Config::builder()
            .add_source(config::File::new(config.to_str().unwrap(), config::FileFormat::Toml)).build().unwrap();

        pic_ox_config.try_deserialize().unwrap()
    }
}